import edu.princeton.cs.algs4.StdOut;

public class Example2 {

    // Implement SmallArray<T> which has the following API:
    //   - public final int K
    //     (a constant that is the max number of elements it contains)
    //   - public SmallArray(T[] elements)
    //   - public int length()
    //   - public T get(int i)
    //     (return the i-th element if i < K and throw an exception
    //     if not in range)

    public static class SmallArray<T> {
        public final int K = 10;
        private T[] container;

        public SmallArray(T[] elements) {
            int elementsToCopy = elements.length;

            if(elementsToCopy > K)
                elementsToCopy = K;

            // create array
            container = (T[]) new Object[elementsToCopy];

            // defensive copy
            for(int i = 0; i < elementsToCopy; i++)
                container[i] = elements[i];
        }

        public int length() { return container.length; }
        public T get(int i) {
            if (i < 0 || i > container.length)
                throw new
                    IndexOutOfBoundsException("array out of bounds");

            return container[i];
        }
    }
            
    
    public static void main(String[] args) {
        // Add these types to get rid of warnings
        String[] array = { "hello", "world", "!" };
        SmallArray<String> sa = new SmallArray<String>(array);
        StdOut.println(sa);

        for(int i = 0; i < sa.length(); i++)
            StdOut.println(sa.get(i));

        sa.get(10);
    }
    
}

